!***********************************************************************
!
!     Fortran-definitions for PCL (Performance Counter Library)
!
!                  PCL - The Performance Counter Library
!
!
!   Copyright (C) 1999, 2000
!   Forschungszentrum Juelich GmbH, Federal Republic of Germany.
!   All rights reserved.
!
!   Redistribution and use in source and binary forms, with or without
!   modification, are permitted provided that the following conditions are met:
!
!   Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
!     - Redistributions of source code must retain the above copyright notice,
!       this list of conditions and the following disclaimer.
!
!     - Redistributions in binary form must reproduce the above copyright
!       notice, this list of conditions and the following disclaimer in the
!       documentation and/or other materials provided with the distribution.
!
!     - Any publications that result from the use of this software shall
!       reasonably refer to the Research Centre's development.
!
!     - All advertising materials mentioning features or use of this software
!       must display the following acknowledgement:
!
!           This product includes software developed by Forschungszentrum
!           Juelich GmbH, Federal Republic of Germany.
!
!     - Forschungszentrum Juelich GmbH is not obligated to provide the user with
!       any support, consulting, training or assistance of any kind with regard
!       to the use, operation and performance of this software or to provide
!       the user with any updates, revisions or new versions.
!
!
!   THIS SOFTWARE IS PROVIDED BY FORSCHUNGSZENTRUM JUELICH GMBH "AS IS" AND ANY
!   EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
!   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
!   DISCLAIMED. IN NO EVENT SHALL FORSCHUNGSZENTRUM JUELICH GMBH BE LIABLE FOR
!   ANY SPECIAL, DIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER
!   RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
!   CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
!   CONNECTION WITH THE ACCESS, USE OR PERFORMANCE OF THIS SOFTWARE.C
!
!***********************************************************************

!*** maximum values
      INTEGER PCL_MAX_EVENT,PCL_MAX_EVENT_PER_CALL,
     +        PCL_MAX_NESTING_LEVEL,PCL_COUNTER_MAX
      PARAMETER(PCL_MAX_EVENT=61,
     +          PCL_MAX_EVENT_PER_CALL=4,
     +          PCL_MAX_NESTING_LEVEL=16,
     +          PCL_COUNTER_MAX=9
     +         )

!*** return codes
      INTEGER PCL_SUCCESS,PCL_NOT_SUPPORTED,PCL_TOO_MANY_EVENTS,
     +        PCL_TOO_MANY_NESTINGS,PCL_ILL_NESTING,PCL_ILL_EVENT,
     +        PCL_MODE_NOT_SUPPORTED,PCL_FAILURE
      PARAMETER(PCL_SUCCESS=0,
     +          PCL_NOT_SUPPORTED=-1,
     +          PCL_TOO_MANY_EVENTS=-2,
     +          PCL_TOO_MANY_NESTINGS=-3,
     +          PCL_ILL_NESTING=-4,
     +          PCL_ILL_EVENT=-5,
     +          PCL_MODE_NOT_SUPPORTED=-6,
     +          PCL_FAILURE=-7
     +     )

!*** define what to count
      INTEGER PCL_MODE_USER,PCL_MODE_SYSTEM,PCL_MODE_USER_SYSTEM
      PARAMETER(PCL_MODE_USER=1,
     +          PCL_MODE_SYSTEM=2,
     +          PCL_MODE_USER_SYSTEM=3
     +     )

!*** events
      INTEGER PCL_L1CACHE_READ,PCL_L1CACHE_WRITE,PCL_L1CACHE_READWRITE,
     +        PCL_L1CACHE_HIT,PCL_L1CACHE_MISS,
     +        PCL_L1DCACHE_READ,PCL_L1DCACHE_WRITE,
     +        PCL_L1DCACHE_READWRITE,PCL_L1DCACHE_HIT,
     +        PCL_L1DCACHE_MISS,
     +        PCL_L1ICACHE_READ,PCL_L1ICACHE_WRITE,
     +        PCL_L1ICACHE_READWRITE,PCL_L1ICACHE_HIT,
     +        PCL_L1ICACHE_MISS,
     +        PCL_L2CACHE_READ,PCL_L2CACHE_WRITE,PCL_L2CACHE_READWRITE,
     +        PCL_L2CACHE_HIT,PCL_L2CACHE_MISS,
     +        PCL_L2DCACHE_READ,PCL_L2DCACHE_WRITE,
     +        PCL_L2DCACHE_READWRITE,PCL_L2DCACHE_HIT,
     +        PCL_L2DCACHE_MISS,
     +        PCL_L2ICACHE_READ,PCL_L2ICACHE_WRITE,
     +        PCL_L2ICACHE_READWRITE,PCL_L2ICACHE_HIT,PCL_L2ICACHE_MISS,
     +        PCL_TLB_HIT,PCL_TLB_MISS,
     +        PCL_ITLB_HIT,PCL_ITLB_MISS, PCL_DTLB_HIT,PCL_DTLB_MISS,
     +        PCL_CYCLES, PCL_ELAPSED_CYCLES,
     +        PCL_INTEGER_INSTR,PCL_FP_INSTR,PCL_LOAD_INSTR,
     +        PCL_STORE_INSTR,PCL_LOADSTORE_INSTR,PCL_INSTR,
     +        PCL_JUMP_SUCCESS,PCL_JUMP_UNSUCCESS,PCL_JUMP,
     +        PCL_ATOMIC_SUCCESS,PCL_ATOMIC_UNSUCCESS,PCL_ATOMIC,
     +        PCL_STALL_INTEGER,PCL_STALL_FP,PCL_STALL_JUMP,
     +        PCL_STALL_LOAD,PCL_STALL_STORE,PCL_STALL,
     +        PCL_MFLOPS,PCL_IPC,
     +        PCL_L1DCACHE_MISSRATE,PCL_L2DCACHE_MISSRATE,
     +        PCL_MEM_FP_RATIO
      PARAMETER(PCL_L1CACHE_READ=0,
     +          PCL_L1CACHE_WRITE=1,
     +          PCL_L1CACHE_READWRITE=2,
     +          PCL_L1CACHE_HIT=3,
     +          PCL_L1CACHE_MISS=4,
     +          PCL_L1DCACHE_READ=5,
     +          PCL_L1DCACHE_WRITE=6,
     +          PCL_L1DCACHE_READWRITE=7,
     +          PCL_L1DCACHE_HIT=8,
     +          PCL_L1DCACHE_MISS=9,
     +          PCL_L1ICACHE_READ=10,
     +          PCL_L1ICACHE_WRITE=11,
     +          PCL_L1ICACHE_READWRITE=12,
     +          PCL_L1ICACHE_HIT=13,
     +          PCL_L1ICACHE_MISS=14,
     +          PCL_L2CACHE_READ=15,
     +          PCL_L2CACHE_WRITE=16,
     +          PCL_L2CACHE_READWRITE=17,
     +          PCL_L2CACHE_HIT=18,
     +          PCL_L2CACHE_MISS=19,
     +          PCL_L2DCACHE_READ=20,
     +          PCL_L2DCACHE_WRITE=21,
     +          PCL_L2DCACHE_READWRITE=22,
     +          PCL_L2DCACHE_HIT=23,
     +          PCL_L2DCACHE_MISS=24,
     +          PCL_L2ICACHE_READ=25,
     +          PCL_L2ICACHE_WRITE=26,
     +          PCL_L2ICACHE_READWRITE=27,
     +          PCL_L2ICACHE_HIT=28,
     +          PCL_L2ICACHE_MISS=29,
     +          PCL_TLB_HIT=30,
     +          PCL_TLB_MISS=31,
     +          PCL_ITLB_HIT=32,
     +          PCL_ITLB_MISS=33,
     +          PCL_DTLB_HIT=34,
     +          PCL_DTLB_MISS=35,
     +          PCL_CYCLES=36,
     +          PCL_ELAPSED_CYCLES=37,
     +          PCL_INTEGER_INSTR=38,
     +          PCL_FP_INSTR=39,
     +          PCL_LOAD_INSTR=40,
     +          PCL_STORE_INSTR=41,
     +          PCL_LOADSTORE_INSTR=42,
     +          PCL_INSTR=43,
     +          PCL_JUMP_SUCCESS=44,
     +          PCL_JUMP_UNSUCCESS=45,
     +          PCL_JUMP=46,
     +          PCL_ATOMIC_SUCCESS=47,
     +          PCL_ATOMIC_UNSUCCESS=48,
     +          PCL_ATOMIC=49,
     +          PCL_STALL_INTEGER=50,
     +          PCL_STALL_FP=51,
     +          PCL_STALL_JUMP=52,
     +          PCL_STALL_LOAD=53,
     +          PCL_STALL_STORE=54,
     +          PCL_STALL=55,
     +          PCL_MFLOPS=56,
     +          PCL_IPC=57,
     +          PCL_L1DCACHE_MISSRATE=58,
     +          PCL_L2DCACHE_MISSRATE=59,
     +          PCL_MEM_FP_RATIO=60
     +     )

      EXTERNAL PCLinit, PCLexit, PCLquery, PCLstart, PCLread, PCLstop
      INTEGER PCLinit, PCLexit, PCLquery, PCLstart, PCLread, PCLstop

C***********************************************************************
