// Java class to test the use of PCL


// import PCL class description
import PCL;


public class pcl_jtest
{
    static final int N = 200;               // matrix dimension
    static double[][] a = new double[N][N];
    static double[][] b = new double[N][N];
    static double[][] c = new double[N][N];


    // test method
    static void matadd(double[][] a, double[][] b, double[][] c)
    {
	int i, j;

	for (i = 0; i < N; ++i)
	    for (j = 0; j < N; ++j)
		a[i][j] = b[i][j] + c[i][j];
    }


    // main program
    public static void main(String[] args)
    {
	int event;
	PCL pcl = new PCL();                   // instantiate PCL
	int mode = pcl.PCL_MODE_USER_SYSTEM;   // count mode
	int[] events = new int[1];             // events; array required
	long[] i_result = new long[1];         // integer results; array required
	double[] fp_result = new double[1];    // floating point results; array required
	long descr = 0;



	// init PCL
	if(pcl.PCLinit(descr) != pcl.PCL_SUCCESS)
	    System.out.println("problem with PCLinit");
	
	// test supported events
	for(event = 0; event < pcl.PCL_MAX_EVENT; ++event)
	    {
		events[0] = event;
		if(pcl.PCLquery(descr, events, 1, mode) == pcl.PCL_SUCCESS)
		    {
			// start counting
			if(pcl.PCLstart(descr, events, 1, mode) != pcl.PCL_SUCCESS)
			    System.out.println("problem with starting event");
			
			// test program
			matadd(a,b,c);

			// stop counting
			if(pcl.PCLstop(descr, i_result, fp_result, 1) != pcl.PCL_SUCCESS)
			    System.out.println("problem with stopping event");

			// print result for event i
			if(event < pcl.PCL_MFLOPS)
			  // integer result
			  System.out.println(pcl.PCLeventname(event) + ":" + i_result[0]);
			else
			  // floating point result
			  System.out.println(pcl.PCLeventname(event) + ":" + fp_result[0]);
		    }
	    }

	if(pcl.PCLexit(descr) != pcl.PCL_SUCCESS)
	    System.out.println("problem with PCLexit");
    }
}
